libstdc++: __gnu_cxx::throw_allocator_base< _Tp, _Cond > Class Template Reference

libstdc++

__gnu_cxx::throw_allocator_base< _Tp, _Cond > Class Template Reference
Utilities » Memory » Allocators

`#include <throw_allocator.h>`

Inheritance diagram for __gnu_cxx::throw_allocator_base< _Tp, _Cond >:
[legend]

## Public Types
typedef const value_type * | const_pointer
typedef const value_type & | const_reference
typedef std::ptrdiff_t | difference_type
typedef value_type * | pointer
typedef std::true_type | propagate_on_container_move_assignment
typedef value_type & | reference
typedef std::size_t | size_type
typedef _Tp | value_type

## Public Member Functions
const_pointer | address (const_reference __x) const noexcept
pointer | address (reference __x) const noexcept
pointer | allocate (size_type __n, const void *__hint=0)
void | check (size_type __n)
map_alloc_type::iterator | check_allocated (void *p, size_t size)
void | check_allocated (pointer __p, size_type __n)
void | check_constructed (size_t label)
map_construct_type::iterator | check_constructed (void *p)
template<typename _Up, typename... _Args>
void | construct (_Up *__p, _Args &&... __args)
void | deallocate (pointer __p, size_type __n)
template<typename _Up>
void | destroy (_Up *__p)
void | erase (void *p, size_t size)
void | erase_construct (void *p)
void | insert (void *p, size_t size)
void | insert_construct (void *p)
size_type | max_size () const noexcept

## Static Public Member Functions
static void | check ()
static size_t | get_label ()
static void | set_label (size_t l)

## Detailed Description

template<typename _Tp, typename _Cond>
class __gnu_cxx::throw_allocator_base< _Tp, _Cond >

Allocator class with logging and exception generation control. Intended to be used as an allocator_type in templatized code.

Note: Deallocate not allowed to throw.

Definition at line 810 of file throw_allocator.h.

## Member Typedef Documentation

## ◆ const_pointer

template<typename _Tp, typename _Cond>

typedef const value_type* __gnu_cxx::throw_allocator_base< _Tp, _Cond >::const_pointer

Definition at line 818 of file throw_allocator.h.

## ◆ const_reference

template<typename _Tp, typename _Cond>

typedef const value_type& __gnu_cxx::throw_allocator_base< _Tp, _Cond >::const_reference

Definition at line 820 of file throw_allocator.h.

## ◆ difference_type

template<typename _Tp, typename _Cond>

typedef std::ptrdiff_t __gnu_cxx::throw_allocator_base< _Tp, _Cond >::difference_type

Definition at line 815 of file throw_allocator.h.

## ◆ pointer

template<typename _Tp, typename _Cond>

typedef value_type* __gnu_cxx::throw_allocator_base< _Tp, _Cond >::pointer

Definition at line 817 of file throw_allocator.h.

## ◆ propagate_on_container_move_assignment

template<typename _Tp, typename _Cond>

typedef std::true_type __gnu_cxx::throw_allocator_base< _Tp, _Cond >::propagate_on_container_move_assignment

Definition at line 825 of file throw_allocator.h.

## ◆ reference

template<typename _Tp, typename _Cond>

typedef value_type& __gnu_cxx::throw_allocator_base< _Tp, _Cond >::reference

Definition at line 819 of file throw_allocator.h.

## ◆ size_type

template<typename _Tp, typename _Cond>

typedef std::size_t __gnu_cxx::throw_allocator_base< _Tp, _Cond >::size_type

Definition at line 814 of file throw_allocator.h.

## ◆ value_type

template<typename _Tp, typename _Cond>

typedef _Tp __gnu_cxx::throw_allocator_base< _Tp, _Cond >::value_type

Definition at line 816 of file throw_allocator.h.

## Member Function Documentation

## ◆ address() [1/2]

template<typename _Tp, typename _Cond>

const_pointer __gnu_cxx::throw_allocator_base< _Tp, _Cond >::address | ( | const_reference | __x | ) | const
| inlinenoexcept

Definition at line 847 of file throw_allocator.h.

## ◆ address() [2/2]

template<typename _Tp, typename _Cond>

pointer __gnu_cxx::throw_allocator_base< _Tp, _Cond >::address | ( | reference | __x | ) | const
| inlinenoexcept

Definition at line 843 of file throw_allocator.h.

## ◆ allocate()

template<typename _Tp, typename _Cond>

pointer __gnu_cxx::throw_allocator_base< _Tp, _Cond >::allocate | ( | size_type | __n,
|  | const void * | __hint = 0 )
| inlinenodiscard

Definition at line 851 of file throw_allocator.h.

## ◆ check() [1/2]

void __gnu_cxx::annotate_base::check | ( |  | ) |
| inlinestaticinherited

Definition at line 238 of file throw_allocator.h.

## ◆ check() [2/2]

template<typename _Tp, typename _Cond>

void __gnu_cxx::throw_allocator_base< _Tp, _Cond >::check | ( | size_type | __n | ) |
| inline

Definition at line 903 of file throw_allocator.h.

## ◆ check_allocated() [1/2]

map_alloc_type::iterator __gnu_cxx::annotate_base::check_allocated | ( | void * | p,
|  | size_t | size )
| inlineinherited

Definition at line 176 of file throw_allocator.h.

## ◆ check_allocated() [2/2]

template<typename _Tp, typename _Cond>

void __gnu_cxx::throw_allocator_base< _Tp, _Cond >::check_allocated | ( | pointer | __p,
|  | size_type | __n )
| inline

Definition at line 896 of file throw_allocator.h.

## ◆ check_constructed() [1/2]

void __gnu_cxx::annotate_base::check_constructed | ( | size_t | label | ) |
| inlineinherited

Definition at line 288 of file throw_allocator.h.

## ◆ check_constructed() [2/2]

map_construct_type::iterator __gnu_cxx::annotate_base::check_constructed | ( | void * | p | ) |
| inlineinherited

Definition at line 273 of file throw_allocator.h.

## ◆ construct()

template<typename _Tp, typename _Cond>
template<typename _Up, typename... _Args>

void __gnu_cxx::throw_allocator_base< _Tp, _Cond >::construct | ( | _Up * | __p,
|  | _Args &&... | __args )
| inline

Definition at line 865 of file throw_allocator.h.

## ◆ deallocate()

template<typename _Tp, typename _Cond>

void __gnu_cxx::throw_allocator_base< _Tp, _Cond >::deallocate | ( | pointer | __p,
|  | size_type | __n )
| inline

Definition at line 889 of file throw_allocator.h.

## ◆ destroy()

template<typename _Tp, typename _Cond>
template<typename _Up>

void __gnu_cxx::throw_allocator_base< _Tp, _Cond >::destroy | ( | _Up * | __p | ) |
| inline

Definition at line 873 of file throw_allocator.h.

## ◆ erase()

void __gnu_cxx::annotate_base::erase | ( | void * | p,
|  | size_t | size )
| inlineinherited

Definition at line 146 of file throw_allocator.h.

## ◆ erase_construct()

void __gnu_cxx::annotate_base::erase_construct | ( | void * | p | ) |
| inlineinherited

Definition at line 170 of file throw_allocator.h.

## ◆ get_label()

size_t __gnu_cxx::annotate_base::get_label | ( |  | ) |
| inlinestaticinherited

Definition at line 120 of file throw_allocator.h.

## ◆ insert()

void __gnu_cxx::annotate_base::insert | ( | void * | p,
|  | size_t | size )
| inlineinherited

Definition at line 124 of file throw_allocator.h.

## ◆ insert_construct()

void __gnu_cxx::annotate_base::insert_construct | ( | void * | p | ) |
| inlineinherited

Definition at line 151 of file throw_allocator.h.

## ◆ max_size()

template<typename _Tp, typename _Cond>

size_type __gnu_cxx::throw_allocator_base< _Tp, _Cond >::max_size | ( |  | ) | const
| inlinenoexcept

Definition at line 839 of file throw_allocator.h.

## ◆ set_label()

void __gnu_cxx::annotate_base::set_label | ( | size_t | l | ) |
| inlinestaticinherited

Definition at line 116 of file throw_allocator.h.

The documentation for this class was generated from the following file:

- throw_allocator.h